#!/usr/bin/env python

"""
Meta Tag Magic -- version 1.1.0 -- July 1999

This module implements some functions to aid Pagecast in looking at
documents, especially meta tags.  Can be configured to modify
documents (update meta tags) when documents are local.

This module is mostly undocumented; it *really* needs to be cleaned up
and documented.

Copyleft (C) 1999 Preston Landers <preston@askpreston.com>
"""

### TODO: this file needs major cleanups and bug fixes.

import urllib
import ConfigParser
import string
import re
import time

def MetaTagMagic(G,config,SubmitList):
    URL_re = re.compile(r"http://.*?/")

    if G.localdocuments == "on":
        # for configuration problems
        TagsConfigException = "There was a problem configuring your local domains for meta tag blessing."
        TagsConfig = ConfigParser.ConfigParser()
        try:
            TagsConfig.read(G.tagsdefs)
            LocalHosts = TagsConfig.sections()
            Mappings = {}
            for Host in LocalHosts:
                hostname = TagsConfig.get(Host,"host")
                Mappings[hostname]=TagsConfig.get(Host,"map")
        except:
            raise TagsConfigException

        for Item in SubmitList:
            for key in Mappings.keys():
                if string.find(Item,key) > -1:
                    match = URL_re.match(Item)
                    if match != None:
                        document = Mappings[key] + Item[match.end():]
                    else:
                        document = Mappings[key] + "index.html"

                    # this modifies files!
                    # document is the path to the file to be modified
                    # must be visible somewhere on a mounted filesystem!
                    if UpdateMetaTags(G,document) == None:
                        G.log.add(G.log.StatusLog("Document " + document + " was not modified due to an error."))

                    # this is so that Apache et al return a recent
                    # document date
                    touch_command = "touch " + document
                    commands.getoutput(touch_command)
    else:
        # pull the document off the web        
        for Item in SubmitList:
            try:
                InputList = urllib.urlopen(Item).readlines()
                Input = ""
                for Line in InputList:
                    Input = Input + Line
                ExamineMetaTags(G,Input, Item)
            except IOError, details:
                if string.find(str(details), "host not found") > -1:
                    G.log.add(G.log.StatusLog("!! " + str(Item) + ": site does not exist or network error."))
                else:
                    G.log.add(G.log.StatusLog("!! " + str(Item) + ": can't open; I/O error."))                    
            except:
                G.log.add(G.log.StatusLog("!! " + str(Item) + " could not be read due to a general error."))
                        

    return 0

def ExamineMetaTags(G,Input, document):
    not_found_match = re.compile(r'<title>.*404.*Not.*Found.*</title>', re.I).search(Input)
    if not_found_match != None:
        G.log.add(G.log.StatusLog("$$ 404 Not Found: " + document))
        G.log.add(G.log.StatusLog("$$ This document was not examined but will be submitted."))
        return None
    
    # check if meta keywords and title match
    # print a warning to the log if they don't
    title_match = re.compile(r'<title>.*?</title>', re.I | re.S).search(Input)
    if title_match != None:
        title = title_match.group()[8:-9]
        titlewords = ShaveStrings(string.split(title))
        # print "titlewords: " + repr(titlewords)
    else:
        titlewords = []
        G.log.add(G.log.StatusLog("Warning! No <title> in document " + document))

    http_equiv_match = re.compile(r'<meta HTTP-EQUIV="keywords" content=".*?">', re.I | re.S).search(Input)
    if http_equiv_match != None:
        G.log.add(G.log.StatusLog("Warning! HTTP-EQUIV keywords obsolete in " + document))
        if G.fixkeywords == "on" and G.localdocuments == "on":
            content_words = http_equiv_match.group()[37:-2]
            keyword_meta_tag = '<meta name="keywords" content="' + content_words + '">'
            G.log.add(G.log.StatusLog("Changing http-equiv keywords to standard keywords in " + document))
            # new meta tag: " + keyword_meta_tag
            Input = Input[:http_equiv_match.start()] + keyword_meta_tag + Input[http_equiv_match.end():]

        
    keywords_match = re.compile(r'<meta name="keywords" content=".*?">', re.I | re.S).search(Input)
    if keywords_match != None:
        keywords_list = keywords_match.group()[31:-2]
        keywords = ShaveStrings(string.split(keywords_list))
        # print "Keywords: " + repr(keywords)
    else:
        keywords = []
        G.log.add(G.log.StatusLog("Warning! No meta keywords in document " + document))
        

    # test confidence of title matching keywords
    lowercase_keywords = map(string.lower, keywords)
    confidence = 0
    for word in titlewords:
        if string.lower(word) in lowercase_keywords:
            confidence = confidence +1

    if confidence < G.confidence_threshold:
        G.log.add(G.log.StatusLog("Warning! Low keyword confidence in " + document + " (" + str(confidence) + ")"))
    else:
        if G.confidence_print == "on":
            G.log.add(G.log.StatusLog("Confidence is " + str(confidence) + " in " + document))
        
    the_time = time.localtime(time.time())
    if the_time[1] < 10:
        month = "0" + str(the_time[1])
    else:
        month = str(the_time[1])
    if the_time[2] < 10:
        day = "0" + str(the_time[2])
    else:
        day = str(the_time[2])        
    the_date = str(the_time[0]) + "-" + month + "-" + day
    DateMetaTag = "<meta name=\"date\" content=\"" + the_date + "\">"
    
    match = re.compile(r'<meta name="date" content=".*?">', re.IGNORECASE).search(Input)
    if match != None:
        # simplest case: date meta tag is already in file
        # so replace it with new tag
        Output = Input[:match.start()] + DateMetaTag + Input[match.end():]
        # print "Replaced meta tag"
    else:
        # otherwise, we have to insert a date meta tag in the <head>
        # if the document doesn't have a header, do nothing
        head_match = re.compile(r"<head>", re.IGNORECASE).search(Input)
        if head_match != None:
            Output = Input[:head_match.end()] + DateMetaTag + Input[head_match.end():]
            # print "Inseted meta tag"
        else:
            # change nothing
            G.log.add(G.log.StatusLog("Warning, this is not a well formed HTML document: " + document))
            return None

    return Output

def ShaveStrings(StringList):
    ReturnList = []
    for eachstring in StringList:
        if ',' in eachstring[-1:]:
            ReturnList.append(eachstring[:-1])
        else:
            ReturnList.append(eachstring)
    return ReturnList

# this is the read/write method of examining & changing local documents
def UpdateMetaTags(G,document):
    try:
        infile = open(document, "r")
        Input = infile.read()
        infile.close()
    except:
        G.log.add(G.log.StatusLog("Document " + document + " could not be opened for reading."))
        return 1

    Output = ExamineMetaTags(Input, document)
    if Output == -1:
        return 1 # test for invalid HTML files

    try:
        Outfile = open(document ,"w")
        Outfile.write(Output)
        Outfile.close()
        G.log.add(G.log.StatusLog("Blessed: " + document))
        return 0
    except:
        G.log.add(G.log.StatusLog("Document " + document + " could not be opened for write."))
        return 1

if __name__ == "__main__":
    print "This is a module; do not run it directly.  Please read the documentation."
    raise SystemExit
