#!/usr/bin/env python

from threading import *
# import ConfigParser

# Load translation tables
try:
    execfile("src/translate.py")
except:
    print "Error loading translation tables in serverbase.py! Aborting. :-("
    raise SystemExit(1)


# helps in getting a unique name for each server
def FindUniqueName(TheDict, DesiredName):
    key = 0
    while DesiredName in TheDict.keys():
        key = key + 1
        DesiredName = DesiredName[:-1] + str(key)
        # print "Trying %s" % (DesiredName)
    return DesiredName

# must respond to a Go() function with the list of URLs as parameter
class ServerObjectBase:
    def __init__(self, G, name = "Unknown"):
        self.G = G
        self.name = name
        self.retries = 0
        
        self.hitcount = 0
        self.timeaccum = 0 # accumulator for performance stats
        self.time = 0 # time for individual requests
        self.avgtime = 0 # stats calculated after run
        self.errorcount = 0 # start with no errors
        self.successcount = 0 # how many URL submissions were totally successful
        self.remote_params = {}
            

# must respond to a Go() function with the list of URLs as parameter        
class ThreadBase(Thread):
    """SEThread -- controls submission of a list of URLs to an individual search engine.
Inherits from Thread."""
    def __init__(self, G, name, ServerObject):
        Thread.__init__(self)

        self.setName(name)   # for thread debugging
        self.name = name     # for quickness
        self.G = G           # set globals
        self.exitflag = None # if set, means to exit ASAP

        # the status states of a SEThread should be:
        # 'init' -> 'started' -> 'active' -> 'idle' -> 'done'
        self.status = "init"

        self.SEO = ServerObject
        

    def Go(self, TheList):
        self.InputList = TheList
        self.start()        
        
    def run(self):        
        # log entrance to thread loop
        self.G.pprint(_("thread_begin") % self.name)

        ev = Event()

        # execute all submissions in input list
        self.status = "active"

        self.SEO.Go(self.InputList)

        self.status = "idle"

        # for educational purposes only
        if self.SEO.hitcount != 0:
            self.avgtime = self.SEO.timeaccum / self.SEO.hitcount
        else:
            self.avgtime = 0
        self.errorcount = self.SEO.errorcount
        self.hitcount = self.SEO.hitcount
        self.successcount = self.SEO.successcount

        # print THREAD EXIT message        
        self.G.pprint(_("thread_exit") % (self.name, self.errorcount, self.successcount, str(round(self.avgtime,2))))

        # clean up
        self.status = "done"
        
