#!/usr/bin/env python

"""smtp wrapper"""

import smtplib, string

class mail_handler:
    def __init__(self, smtp_server, From):
        self.server_name = smtp_server
        self.From = From
        
    def send_email(self, To, Subject, Body, CC = None, BCC = None):
        """returns None on success, else the error message"""

        addrs = [To]

        if CC:
            addrs = addrs + string.split(CC, ",")

        if BCC:
            addrs = addrs + string.split(BCC, ",")

        # strip whitespace
        addrs = map(string.strip, addrs)
        
        Body = "From: %s\nSubject: %s\n\n%s\n" % (self.From, Subject, Body)

        for address in addrs:

            try:
                server = smtplib.SMTP(self.server_name)
                server.sendmail(self.From, address, Body)
                server.quit()
                return 
            except smtplib.SMTPException, msg:
                return msg
        

if __name__ == "__main__":
    
    To = "pbl@pbl.cx"
    BCC = "planders@pbl.cx, pibble@yahoo.com"
    CC = "pibble@yahoo.com"
    Subject = "Testing SMTP lib 3"
    Body = "Hello, I am testing the SMTP lib\nThis is fun.\n"
    From = "Hank Williams <planders@pbl.cx>"
    server = "mail.pbl.cx"

    mh = mail_handler(server, From)
    result = mh.send_email(To, Subject, Body, CC, BCC)
    if result:
        print "Error: %s" % result
    else:
        print "Mail successfully sent."
