#!/usr/bin/env python

Lookups = {
    "version" : "Pagecast 2.0 beta 1",
    "copyright" : "Copyleft (C) 2000 Preston Landers <pbl@pbl.cx> All Rights Reserved",
    "help" : """Pagecast 2.0 beta 1 -- Copyleft 2000 Preston Landers <pbl@pbl.cx>

Description: Automates submitting a list of URL's to various Internet
web search engines (AltaVista, Excite, etc.)  The input (a file or
stdin) should consist of one URL per line.  If a network interface
such as http:// is not present in the URL, by default it will be added.

Usage:
 pagecast url-file   <-- parses URLs in the file url-file
 pagecast            <-- parses URLs from standard input
 pagecast -g group   <-- only submit to sites belong to group
 pagecast -h         <-- this help message
 pagecast -v         <-- enable verbose / debugging statements
                         (use multiple times for extra verbosity)

Configuration:
 edit these files with a plain text editor:
   ./etc/pagecast.conf  [general configuration]
   ./etc/servers.conf   [search engine configuration]
   ./etc/tags.conf      [locally hosted domains (optional)]
   
 See the ./documentation/README file for more detailed instructions.
 See the ./documentation/COPYING file for the license.  NO WARRANTY PROVIDED.""",

    "config_parse_error" : "There was a problem loading or parsing the configuration files, aborting.",
    "server_parse_error" : "There was a problem configuring servers; exiting.",

    # date, version
    "begin_run_msg" : "[%s] === %s === Beginning Run",

    # URL
    "broken_link" : "!! Warning: %s not submitted; URL is broken",
    "user_quit" : "User requested quit; cleaning up.",
    "done_message" : "=== All operations completed; closing down.",

    # URLcount, servercount, successcount, failcount
    "summary" : "SUMMARY: <%d> URLs were submitted to %d servers.\n       : with <<%d>> successes and (%d) problem URLs.",

    # servername, URL
    "unhandled_exception" : "Oops! Unhandled exception in %s during %s.",

    # servername, URL
    "submit_success" : "%s ; URL submitted: %s",

    # servername, URL, failure reason
    "submit_fail" : "%s ; @ <Error> %s : %s",

    # servername, URL
    "generic_fail" : "%s ; @ <Error> %s [Generic]",

    # servername, URL
    "no_results_fail" :"%s ; @ <Error> %s [No Results]",
    
    # servername
    "network_error" : "@ %s <Error> $ Network Lookup/Access Failure",

    # servername
    "thread_begin" : "## %s ; Beginning execution.",

    # servername, errorcount, successcount, average time to complete
    "thread_exit" : "&& %s completed with %d error[s] and <<%d>> successful; AvgTime: %ss",

    # servername, default groups
    "default_groups_msg" : "%s assigned default groups %s",
    
    ###
    ### DEBUG stuff 
    ###
    "d_language" : "US English",

    "d_active_groups" : "The following groups will be activated: %s",
    
    # groups (specified on the command line)
    "d_specified_groups" : "These command-line groups will be activated: %s",

    # servername, server's groups
    "d_server_activated" : "%s activated; member of: %s",

    # servername, machine address, port, path
    "d_server_configured" : "Configured %s @ %s:%s%s",

    # URL, servername
    "d_request_submit" : "Submitting %s to %s",

    # servername
    "d_request_complete" : "Completed request to %s",

    # servername, retry number
    "d_retrying" : "Retrying %s try #%d",

    "bad_mail_configure" : "There was a problem configuring the mail response; continuing.",

    # servername, successcount, to-address
    "mail_success": "%s ; %d URLs submitted by mail to <%s>"
    }

global _
def _(astring):
    if astring in Lookups.keys():
        return Lookups[astring]
    else:
        return astring
